<?php

namespace ChangeCommerce\Core\Observer\Implementations;

use Magento\Framework\Event\Observer;
use Magento\Framework\Serialize\Serializer\Json;
use Magento\Framework\HTTP\Adapter\Curl;
use Magento\Framework\MessageQueue\Publisher;
use ChangeCommerce\Core\Model\OrderWebhookFailureFactory;
use ChangeCommerce\Core\Logger\Logger;
use ChangeCommerce\Core\Helpers\OrderObjHelper;
use ChangeCommerce\Core\Observer\AbstractOrderObserver;
use ChangeCommerce\Core\Model\Config\Data as Config;

class AfterCancelOrderObserver extends AbstractOrderObserver
{
    public function __construct(
        Curl $curlAdapter,
        Json $jsonHelper,
        Publisher $publisher,
        Logger $logger,
        OrderWebhookFailureFactory $failureFactory,
        OrderObjHelper $orderObjHelper,
        Config $config)
    {
        $uri = $config->getOrderCancelWebhookUri();
        $verb = 'DELETE';
        $hookName = 'AfterCancelOrder';
        $topic = 'changecommerce.core.order.cancel';

        parent::__construct($curlAdapter, $jsonHelper, $publisher, $logger, $failureFactory, $orderObjHelper, $config,
            $uri, $verb, $hookName, $topic);
    }

    protected function getOrderId(Observer $observer) {
        return $observer->getEvent()->getOrder()->getIncrementId();
    }
}
