<?php

namespace ChangeCommerce\Core\Observer\Implementations;

use Magento\Framework\Event\Observer;
use Magento\Framework\Serialize\Serializer\Json;
use Magento\Framework\HTTP\Adapter\Curl;
use Magento\Framework\MessageQueue\Publisher;
use ChangeCommerce\Core\Model\OrderWebhookFailureFactory;
use ChangeCommerce\Core\Logger\Logger;
use ChangeCommerce\Core\Helpers\OrderObjHelper;
use ChangeCommerce\Core\Observer\AbstractOrderObserver;
use ChangeCommerce\Core\Model\Config\Data as Config;

class AfterCreditMemoObserver extends AbstractOrderObserver
{
    protected $orderRepository;

    public function __construct(
        Curl $curlAdapter,
        Json $jsonHelper,
        Publisher $publisher,
        Logger $logger,
        OrderWebhookFailureFactory $failureFactory,
        OrderObjHelper $orderObjHelper,
        Config $config,
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository)
    {
        $uri = $config->getOrderCreditWebhookUri();
        $verb = 'PUT';
        $hookName = 'AfterCreditMemo';
        $topic = 'changecommerce.core.order.creditmemo';

        $this->orderRepository = $orderRepository;

        parent::__construct($curlAdapter, $jsonHelper, $publisher, $logger, $failureFactory, $orderObjHelper, $config, 
            $uri, $verb, $hookName, $topic);
    }

    protected function getOrderId(Observer $observer) {
        return $this->orderRepository->get($observer->getEvent()->getCreditmemo()->getOrderId())->getIncrementId();
    }
}
